#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

//#define FEI		  
//#define FEE		
//#define FBI		
#define FBE   


/*********************************************************************/
/*  Function declarations                                            */
/*********************************************************************/

void MCU_Init(void) {
  
  SOPT1 = 0x23;          /* Watchdog disable */  
}

void GPIO_Init(void) { 
  
  PTEDD = 0x01;          /* Configure PTE port as output */
  PTED = 0x00;           /* Put 0's in PTE port */
}

  
void ICS_configuration(void) {
  
  #ifdef FEI
  ICSC1 = 0b00000100;
  ICSC2 = 0b10110111;
  ICSTRM = 0x1D; /* Initialize ICSTRM register from a non volatile memory */
  ICSSC = 0x31;  /* Initialize ICSSC register from a non volatile memory */
  while (ICSC1_CLKS != ICSSC_CLKST) {}
  #endif

  #ifdef FEE
  ICSC1 = 0b00101000;
  ICSC2 = 0b01010111;
  ICSSC = 0x31;  /* Initialize ICSSC register from a non volatile memory */
  while (ICSC1_CLKS != ICSSC_CLKST) {}
  #endif

  #ifdef FBE
  ICSC1 = 0b10000000;        
  ICSC2 = 0b11000000;       
  ICSSC = 0x31;  /* Initialize ICSSC register from a non volatile memory */
  #endif
  
  #ifdef FBI
  ICSC1 = 0b01000100;        
  ICSC2 = 0b01000000;        
  ICSSC = 0x31;  /* Initialize ICSSC register from a non volatile memory */
  while (ICSC1_CLKS != ICSSC_CLKST) {}  
  #endif FBI
}


/*********************************************************************/
/*  Main Function                                                    */
/*********************************************************************/

void main(void) {

  MCU_Init();
  GPIO_Init();
  ICS_configuration();
                 
  EnableInterrupts;  /* enable interrupts */

  for(;;) {
  
  PTED_PTED7 ^= 1;
  
  } /* loop forever */
  /* please make sure that you never leave this function */
}

